/********************************** (C) COPYRIGHT *******************************
* File Name          : ISP_DEMO.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/3/8
* Description        : CH561 ISP DEMO
*                     
*                      (1)0Ϣ,115200bps;
*                      (2)ʾISPأдɹоƬϵ缴ͨISP

˵:ӿļ\SRC\ISPXT56X.O
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>


#include "CH561SFR.H"
#include "SYSFREQ.H"
#include "ISPXT56X.H"
                              

/* һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( LED )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }       /* LED ߵƽΪ */
#define LED_OUT_ACT( LED )      { R32_PB_CLR |= LED; }                          /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT( LED )    { R32_PB_OUT |= LED; }                          /* LED ߵƽرLEDʾ */

__align(4) UINT8  TestBuf[1024*4];                                              //ûڵISPõغʱһʱ

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS/ 8 / 115200;                                              /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/
int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void ) 
{
    UINT8 i,my_buffer[8];

    R32_PB_DIR &=  ~(1<<7);                                                     // PB7                                
    R32_PB_PU  |=  (1<<7);                   
    mInitSTDIO();                                                               
    PRINT("Edit Date and Time is: "__DATE__" , " __TIME__"\n");
    GET_UNIQUE_ID( my_buffer );
    PRINT("chip id: ");
    for(i=0;i<8;i++) PRINT("%-2x ",my_buffer[i]);
    PRINT("\n");

    while(1){
        if( (R32_PB_PIN & (1<<7) )== 0  ){                                      // õĸ
            Delay_ms(50);
            if( (R32_PB_PIN & (1<<7) )== 0  ){
                while( (R32_PB_PIN & (1<<7) )== 0  );
                PRINT("ISP TEST\n");
                i = CH56X_EnterIspSet( TestBuf );
                if(i == 0)
                {
                    printf("entry isp success\n");
                                                                                //ڿԽоƬ磬ϵ缰ISP
                }
            }
        }
    }
}

/*********************************** endfile **********************************/
