/********************************** (C) COPYRIGHT ******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/3/8
* Description        : CH561NETʾ
*                    
*******************************************************************************/

/*******************************************************************************
CH561 TCP/IP Эӿ
CH561NETʾļDNSʾ

˵ӿļ\SRC\ISPXT56X.O \NET\PUB CH561NET.lib

*******************************************************************************/

/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include "CH561SFR.H"
#include "SYSFREQ.H"
#include "ISPXT56X.H"


void ResetSys(void);
/****************************************************************************/

/*  */
/* MAC շ */
/* CH561NET.LIB ڲ (RX_QUEUE_ENTRIES + TX_QUEUE_ENTRIES)*MAX_PKT_SIZE ֽڵĻ̫շ */
/* û޸RX_QUEUE_ENTRIESTX_QUEUE_ENTRIESٻڲ, TX_QUEUE_ENTRIESΪ2ɣRX_QUEUE_ENTRIES*/
/* ҪʵеҪݽշRX_QUEUE_ENTRIES󣬷ܻᶪʧݡ*/
#define CH563NET_PING_ENABLE                 TRUE                    /* PINGFALSEΪرգ */
/* ͷļúļЧ */


#define CH563NET_MAX_SOCKET_NUM               4                                 /* SocketĸûãĬΪ4Socket,Ϊ32 */
#define RECE_BUF_LEN                          (CH563NET_TCP_MSS * 2  )                               
#define CH563NET_TCP_MSS                      536                               /* tcp MSSĴС*/
#define CH561NET_DBG                          1

#include "CH561NET.H"

/* ĻȫֱҪ壬е */
__align(16)UINT8  CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                     /* MAC16ֽڶ */
__align(4)UINT8   CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                  /* MACջ4ֽڶ */
__align(4)SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];                          /* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
                         CH563NET_NUM_UDP,
                         CH563NET_NUM_TCP,
                         CH563NET_NUM_TCP_LISTEN,
                         CH563NET_NUM_TCP_SEG,
                         CH563NET_NUM_IP_REASSDATA,
                         CH563NET_NUM_PBUF,
                         CH563NET_NUM_POOL_BUF
                         };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
                          CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
                         };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];

/*=============================================================================*/
/* CH561ض */
UINT8 MACAddr[6] = {0x02,0x03,0x04,0x05,0x06,0x07};                             /* MACַ */

UINT8 IPAddr[4] = {192,168,0,11};                                               /* IPַ */
UINT8 GWIPAddr[4] = {192,168,0,1};                                              /*  */
UINT8 IPMask[4] = {255,255,255,0};                                              /*  */
UINT8 RemoIP[4] = {192,168,0,3};                                                /*  */
UINT8 SocketId;                                                                 /* socketԲö */

UINT8 SocketRecvBuf[CH563NET_MAX_SOCKET_NUM][RECE_BUF_LEN];                     /* socketջ */
UINT8 MyBuf[RECE_BUF_LEN];                                                      /* һʱ */
#define SEND_BUF_COUNT                               5
UINT8 UDPServerFlag = 0 ;

UINT8 DNSHostIP[4] = {8,8,8,8};

UINT16 DNSPort = 53;
UINT8 RemoteIp[4];

UINT8 DNSGetFlag = 0;
/******************************************************************************/
/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
__irq void IRQ_Handler( void )
{
    if(R32_INT_FLAG & 0x8000)                                                   /* ̫ж */
    {                                                                           /* ̫жжϷ */
        CH563NET_ETHIsr();
    }
    if(R32_INT_FLAG & RB_IF_TMR0)                                               /* ʱж */
    {
         CH563NET_TimeIsr(CH563NETTIMEPERIOD);                                  /* ʱжϷ */
         R8_TMR0_INT_FLAG |= 0xff;                                              /* ʱжϱ־ */
    }
}


__irq void FIQ_Handler( void )
{

}

/*******************************************************************************
* Function Name  : SysTimeInit
* Description    : ϵͳʱʼ100MHZ TIME0 10msCH563NETTIMEPERIOD
*                ʼʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTimeInit(void)
{
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR0_COUNT = 0x00000000; 
    R32_TMR0_CNT_END = 0x186a0 * CH563NETTIMEPERIOD;                            /* Ϊ10MSʱ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}
/*******************************************************************************
* Function Name  : InitSysHal
* Description    : ӲʼTIM0ETHж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSysHal(void)
{
    R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR0;                                          /* TIM0ж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;                                           /* ETHж */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* IRQȫж */
}

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH563NET_ERR_SUCCESS) return;                                 /* ɹ */
    printf("Error: %02X\n", (UINT16)iError);                                    /* ʾ */
}

/*******************************************************************************
* Function Name  : CH561NET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                 : mask    ָ
*                 : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH561NET_LibInit(const UINT8 *ip,const UINT8 *gwip,const UINT8 *mask,const UINT8 *macaddr)
{
   UINT8 i;
   struct _CH563_CFG cfg;

    if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH563NETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss = CH563NET_TCP_MSS;
    cfg.HeapSize = CH563_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
    CH563NET_ConfigLIB(&cfg);
    i = CH563NET_Init(ip,gwip,mask,macaddr);
    return (i);                      /* ʼ */
}

/*******************************************************************************
* Function Name  : CH561NET_HandleSockInt
* Description    : Socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH561NET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;


    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
        len = CH563NET_SocketRecvLen(sockeid,NULL);                             /* Ὣǰָ봫ݸprecv*/
        CH563NET_SocketRecv(sockeid,MyBuf,&len);                                /* ջݶMyBuf*/

    
    }
    if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
    {
        CH563NET_ModifyRecvBuf(sockeid,(UINT32)SocketRecvBuf[sockeid],RECE_BUF_LEN);  

    }
    if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
    {
        CH563NET_SocketClose(sockeid,0);
        
    }
    if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
    {
#if CH561NET_DBG
        printf("SINT_STAT_TIM_OUT\n");                           
#endif
    }
}

/*******************************************************************************
* Function Name  : CH561NET_HandleGloableInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH561NET_HandleGloableInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    
    initstat = CH563NET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
      
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
   
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
        i = CH563NET_GetPHYStatus();                                             /* ȡPHY״̬ */
#if CH561NET_DBG
        printf("GINT_STAT_PHY_CHANGE %02x\n",i);
#endif  
        if(i&PHY_DISCONN)
        {
          
        }
        else
        {
             DNSGetFlag = 1;
        }
        
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i++)                     
       {
           socketinit = CH563NET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH561NET_HandleSockInt(i,socketinit);                  /* ж */
       }    
   }
}



/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : ڳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO(void)
{
    UINT32    x, x2;
    x = 10 * FREQ_SYS * 2 / 16 / 115200;  // 115200bps
//    x = 10 * 62500000 * 2 / 16 / 115200;  // Ĭ62.5MHz
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;  // 
    R8_UART0_LCR = 0x80;  // DLABλ1
    R8_UART0_DIV = 1;  // ԤƵ
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;
    R8_UART0_LCR = 0x03;
    R8_UART0_FCR = 0xC7;
    R8_UART0_IER = RB_IER_TXD_EN;  // TXD enable
    R32_PB_SMT |= RXD0|TXD0;  // RXD0 schmitt input, TXD0 slow rate
    R32_PB_PD &= ~ RXD0;  // disable pulldown for RXD0, keep pullup
    R32_PB_DIR |= TXD0;  // TXD0 output enable
}

/* ͨϢ */
int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                            // 
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );       // ȴݷ
    return( c );
}

/*******************************************************************************
* Function Name  : CH561NET_DNSCallBack
* Description    : DNSص
* Input          : None
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
void  CH561NET_DNSCallBack(const  char  *name,  UINT8  *ipaddr,  void  *callback_arg) 
{ 
    if(ipaddr == NULL) 
    { 
        printf("DNS Fail\n"); 
        return; 
    } 
#if CH561NET_DBG
    printf("Host Name = %s\n",name); 
    printf("IP= %d.%d.%d.%d\n",ipaddr[0],ipaddr[1],ipaddr[2],ipaddr[3]); 
    if(callback_arg != NULL) 
    { 
        printf("callback_arg = %02x\n",(*(UINT8 *)callback_arg)); 
    } 
#endif
} 

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void) 
{
    UINT8 i = 0;

    mInitSTDIO();
    CH563NET_InitDNS(DNSHostIP,DNSPort); 
    i = CH56X_GetMac(MACAddr);
    i = CH561NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */
    mStopIfError(i);                                                            /*  */
    SysTimeInit();                                                              /* ϵͳʱʼ */
    InitSysHal();                                                               /* ʼж */
    while(1)
    {
        CH563NET_MainTask();                                                    /* NETҪѭвϵ */
        if(CH563NET_QueryGlobalInt())CH561NET_HandleGloableInt();               /* ѯжϣжϣȫжϴ */
        if(DNSGetFlag)
        {
            DNSGetFlag = 0;
            i= CH563NET_GetHostName("www.wch.cn",RemoteIp,CH561NET_DNSCallBack,NULL);
            if(i == 0) 
            { 
    #if CH561NET_DBG
                printf("561NET_GetHostName Success\n"); 
                printf("IP= %d.%d.%d.%d\n",RemoteIp[0],RemoteIp[1],RemoteIp[2],RemoteIp[3]); 
    #endif
                while(1);
            } 
        }
    }
}


/****************************endfile@tech9*************************************/
