/********************************** (C) COPYRIGHT ******************************
* File Name          : CH561.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/3/8
* Description        :ʾλͨUDP㲥CH561Ĺ.
                       561һUDP serverλͨ

˵ӿļ\SRC\ISPXT56X.O \NET\PUB CH561NET.lib
*******************************************************************************/



/******************************************************************************/
/* ͷļ*/
#include <stdio.h>
#include <string.h>
#include "CH561SFR.H"
#include "SYSFREQ.H"
#include "ModuleConfig.h"
#include "CH561NET.H"
#include "ISPXT56X.H"
#define  CH561NET_DBG                          1

/* ĻȫֱҪ壬е */
__align(16)UINT8    CH563MACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                   /* MAC16ֽڶ */
__align(4) UINT8    CH563MACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH563NET_MAX_SOCKET_NUM];                         /* SocketϢ4ֽڶ */
const UINT16 MemNum[8] = {CH563NET_NUM_IPRAW,
                       CH563NET_NUM_UDP,
                       CH563NET_NUM_TCP,
                       CH563NET_NUM_TCP_LISTEN,
                       CH563NET_NUM_TCP_SEG,
                       CH563NET_NUM_IP_REASSDATA,
                       CH563NET_NUM_PBUF,
                       CH563NET_NUM_POOL_BUF
                       };
const UINT16 MemSize[8] = {CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IPRAW_PCB),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_UDP_PCB),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_PCB_LISTEN),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_TCP_SEG),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_IP_REASSDATA),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(0),
                        CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_PBUF) + CH563NET_MEM_ALIGN_SIZE(CH563NET_SIZE_POOL_BUF)
                       };
__align(4)UINT8 Memp_Memory[CH563NET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH563NET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH563NET_RAM_ARP_TABLE_SIZE];
/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN                          1600                              /* ջĴС */                   
                                                                                                                         
/* CH563ض */
UINT8 Default_MAC[6]={0X02,0X03,0X04,0X05,0X06,0X07};                     
UINT8 MACAddr[6];                                                               /* MACַ */                       
UINT8 IPAddr[4];                                                                /* IPַ */                        
UINT8 GWIPAddr[4];                                                              /*  */                          
UINT8 IPMask[4];                                                                /*  */                      
UINT8 SocketId;                                                                 /* socketԲö */       
UINT8 SocketRecvBuf[CH563NET_MAX_SOCKET_NUM ][RECE_BUF_LEN];                    /* socketջ */                   
UINT8 MyBuf[RECE_BUF_LEN];                                                      /* һʱ */                 
UINT8 Configbuf[MODULE_CFG_LEN];
pmodule_cfg CFG = (pmodule_cfg)Configbuf;
UINT8 socket_flag;                                                              /*ʾλõʲôģʽ*/


/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
__irq void IRQ_Handler( void )
{
    if(R32_INT_FLAG & 0x8000)                                                   /* ̫ж */
    {                                                                           /* ̫жжϷ */
        CH563NET_ETHIsr();
    }
    if(R32_INT_FLAG & RB_IF_TMR0)                                               /* ʱж */
    {
        CH563NET_TimeIsr(CH563NETTIMEPERIOD);                                   /* ʱжϷ */
        R8_TMR0_INT_FLAG |= 0xff;                                               /* ʱжϱ־ */
   }
}

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : SysTimeInit
* Description    : ϵͳʱʼ@100MHZ TIME0 10msCH563NETTIMEPERIOD
*                ʼʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTimeInit(void)
{
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R32_TMR0_COUNT = 0x00000000; 
    R32_TMR0_CNT_END = 0x186a0 * CH563NETTIMEPERIOD;                            /* Ϊ10MSʱ */
    R8_TMR0_INTER_EN |= RB_TMR_IE_CYC_END;
    R8_TMR0_CTRL_MOD = RB_TMR_COUNT_EN;
}

/*******************************************************************************
* Function Name  : InitSysHal
* Description    : ӲʼTIM0ETHж
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSysHal(void)
{
    R8_INT_EN_IRQ_0 |= RB_IE_IRQ_TMR0;                                          /* TIM0ж */
    R8_INT_EN_IRQ_1 |= RB_IE_IRQ_ETH;                                           /* ETHж */
    R8_INT_EN_IRQ_GLOB |= RB_IE_IRQ_GLOB;                                       /* IRQȫж */
}

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH563NET_ERR_SUCCESS) return;                                 /* ɹ */
#if CH561NET_DBG
    printf("Error: %02X\n", (UINT16)iError);                                    /* ʾ */
#endif    
}


void CH561_RESET()
{
#if CH561NET_DBG
    printf("reset \n");
#endif  
    R8_SAFE_ACCESS_SIG = 0x57 ;                                                 /* unlock step 1 */
    R8_SAFE_ACCESS_SIG = 0xA8 ;                                                 /* unlock step 2 */                     
    R8_GLOB_RST_CFG = 0x40 | RB_GLOB_FORCE_RST;                                 /*λ*/  
    R8_SAFE_ACCESS_SIG = 0;                                                     /* ֹд */
}


/*******************************************************************************
* Function Name  : CH561NET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                 : mask    ָ
*                 : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH561NET_LibInit( UINT8 *ip, UINT8 *gwip, UINT8 *mask, UINT8 *macaddr)
{
    UINT8 i;
    struct _CH563_CFG cfg;
    if(CH563NET_GetVer() != CH563NET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH563NETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH563NET_TCP_MSS;
    cfg.HeapSize = CH563_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH563NET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH563NET_MISC_CONFIG0;
    CH563NET_ConfigLIB(&cfg);
    i = CH563NET_Init(ip,gwip,mask,macaddr);
    return (i);              /* ʼ */
}


void CH561NET_UdpServerRecv(struct _SCOK_INF *socinf,UINT32 ipaddr,UINT16 port,UINT8 *buf,UINT32 len)
{
    UINT8 i;    
     
    i =ParseConfigbuf(buf) ;                                                    /**/
    if(i){
     CH561_RESET();
    }                 
}



void CH561NET_UdpSRecv(struct _SCOK_INF *socinf,UINT32 ipaddr,UINT16 port,UINT8 *buf,UINT32 len)
{
  UINT8 ip_addr[4],i;
  
  printf("ip:");
  for(i=0;i<4;i++){
    ip_addr[i]=ipaddr&0xff;
    printf("%-4d",ip_addr[i]);
    ipaddr=ipaddr>>8;
  }
#if CH561NET_DBG
  printf("port=%-8d  len=%-8d  sockeid=%-4d\n",port,len,socinf->SockIndex);
#endif  
  CH563NET_SocketUdpSendTo(socinf->SockIndex,buf,&len,ip_addr,port);
}

void CH561NET_Creat_Communication_Socket(void)
{   
   UINT8 i;                                                             
   UINT8 *desip=CFG->dest_ip;                                                   /* ĿIPַ */
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */
   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,desip,4);                                 /* ĿIPַ */
   TmpSocketInf.DesPort = ((UINT16)CFG->dest_port[0]+(UINT16)CFG->dest_port[1]*256);                /* ĿĶ˿ */
   TmpSocketInf.SourPort = ((UINT16)CFG->src_port[0]+(UINT16)CFG->src_port[1]*256);                 /* Դ˿ */
   switch(CFG->type){
     case NET_MODULE_TYPE_TCP_S:     
          TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                              /* socekt */         
          socket_flag= NET_MODULE_TYPE_TCP_S;
          break;
     case NET_MODULE_TYPE_TCP_C:
          TmpSocketInf.ProtoType = PROTO_TYPE_TCP;          
          socket_flag= NET_MODULE_TYPE_TCP_C;
          break;
     case NET_MODULE_TYPE_UDP_S:
          TmpSocketInf.ProtoType = PROTO_TYPE_UDP;
          TmpSocketInf.AppCallBack = CH561NET_UdpSRecv;
          socket_flag= NET_MODULE_TYPE_UDP_S;
          break;
     case NET_MODULE_TYPE_UDP_C:
          TmpSocketInf.ProtoType = PROTO_TYPE_UDP;
          socket_flag= NET_MODULE_TYPE_UDP_C;
          break; 
     default:
          break;
   }     
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf[1];                      /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
   switch(CFG->type){
     case NET_MODULE_TYPE_TCP_S:
          CH563NET_SocketListen(SocketId);
          printf("listening\n");
          break;
     case NET_MODULE_TYPE_TCP_C:
          CH563NET_SocketConnect(SocketId);
          printf("connecting\n");
          break;
     default:
          break;
   }

}

/*******************************************************************************
* Function Name  : CH561NET_HandleSockInt
* Description    : Socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH561NET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;


    if(initstat & SINT_STAT_RECV) {                                             /* ж */
      len = CH563NET_SocketRecvLen(sockeid,NULL);                               /* ѯ */
      CH563NET_SocketRecv(sockeid,MyBuf,&len);                                  /* ջݶMyBuf*/           
    }
    if(initstat & SINT_STAT_CONNECT) {                                          /* TCPж */
      if(socket_flag==NET_MODULE_TYPE_TCP_S){
        CH563NET_ModifyRecvBuf(sockeid,(UINT32)SocketRecvBuf[sockeid],RECE_BUF_LEN);
      }                    
    }
    if(initstat & SINT_STAT_DISCONNECT){                                        /* TCPϿж */    
      Delay_ms(200);
      CH561NET_Creat_Communication_Socket();      
    }
    if(initstat & SINT_STAT_TIM_OUT){                                           /* TCPʱж */

      Delay_ms(200);
      CH561NET_Creat_Communication_Socket();     
    }

}

/*******************************************************************************
* Function Name  : CH561NET_HandleGloableInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH561NET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    
    initstat = CH563NET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
#if CH561NET_DBG
        printf("UnreachCode %d\n",CH563Inf.UnreachCode);                      /* 鿴ɴ */
        printf("UnreachProto %d\n",CH563Inf.UnreachProto);                    /* 鿴ɴЭ */
        printf("UnreachPort %d\n",CH563Inf.UnreachPort);                      /* ѯɴ˿ */
#endif       
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
   
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
       i = CH563NET_GetPHYStatus();                                             /* ȡPHY״̬ */
#if CH561NET_DBG
       printf("GINT_STAT_PHY_CHANGE %02x\n",i);
#endif   
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH563NET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH563NET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH561NET_HandleSockInt(i,socketinit);                  /* ж */
       }    
   }
}




/*******************************************************************************
* Function Name  : CH561NET_CreatUdpSocket
* Description    : UDP socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH561NET_CreatUdpSocket(void)
{
   UINT8 i;                                                             
   UINT8 desip[4] = {255,255,255,255};                                          /* ĿIPַ */
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,desip,4);                                 /* ĿIPַ */
   TmpSocketInf.DesPort = 60000;                                                /* ĿĶ˿ */
   TmpSocketInf.SourPort = 50000;                                               /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_UDP;                                     /* socekt */
   TmpSocketInf.AppCallBack = CH561NET_UdpServerRecv;
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf[0];                       /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH563NET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
}




/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD1 schmitt input, TXD1 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD1 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}




/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void ) 
{
    UINT8 i = 0;
  
    mInitSTDIO( );                                                              /* Ϊüͨڼʾ */   
    R32_PB_PU  |=1<<6;
    R32_PB_DIR &=~(1<<6);
    EEPROM_READ( 0x1000,CFG,MODULE_CFG_LEN );                                   /* ȡEEPROMﱣϢ */   
    if(CFG->cfg_flag[0]!=checkcode1||CFG->cfg_flag[1]!=checkcode2){             /*УEEPROMϢǷϷ*/                                                                               /*EEPROMﱣϢϷ561δλ,ôͰĬʼ561*/                                                                                                         
      i = EEPROM_ERASE(0x1000,4096);                                                   
      i = EEPROM_WRITE(0x1000,Default_cfg,MODULE_CFG_LEN );                                       
      CH561_RESET();
    }
    i=CH56X_GetMac( MACAddr ); 
    if(i){                                                                      /*ȡeeprommacʧܣô561ʹĬMAC*/
      memcpy(MACAddr,Default_MAC,6);
    }
#if CH561NET_DBG    
    printf("MACAddr:");    
    for(i=0;i<6;i++){
      printf("%02x  ",MACAddr[i]);
    }
    printf("\n");
#endif
    memcpy(IPAddr,CFG->src_ip,sizeof(CFG->src_ip));         
    memcpy(GWIPAddr,CFG->getway,sizeof(CFG->getway));   
    memcpy(IPMask,CFG->mask,sizeof(CFG->mask));       
    i = CH561NET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */
    mStopIfError(i);                                                            /*  */
#if CH561NET_DBG
     printf(" 561 ip:%d.%d.%d.%d\n 561 gwip:%d.%d.%d.%d\n 561 mask:%d.%d.%d.%d\n", IPAddr[0],IPAddr[1],IPAddr[2],IPAddr[3],\
            GWIPAddr[0],GWIPAddr[1],GWIPAddr[2],GWIPAddr[3],IPMask[0],IPMask[1],IPMask[2],IPMask[3]); 
     printf("CH561IPLibInit Success\n");
#endif    
    SysTimeInit();                                                              /* ϵͳʱʼ */
    InitSysHal();                                                               /* ʼж */
    CH561NET_CreatUdpSocket();                                                  /* UDP Socket */
    if(CFG->type!=NET_MODULE_TYPE_NONE){                                        /*Ĭ²κģʽ*/      
    CH561NET_Creat_Communication_Socket();                                      /*λģʽµsocket*/
    }  
    if((R32_PB_PIN&(1<<6))==0) {                                                /*º󣬳ʼ561ִĬ*/ 
       Delay_ms(50);
       if((R32_PB_PIN&(1<<6))==0){      
				 while((R32_PB_PIN&(1<<6))==0);
       i = EEPROM_ERASE(0x1000,4096);
       i = EEPROM_WRITE( 0x1000,(pmodule_cfg)Default_cfg,MODULE_CFG_LEN );   
       CH561_RESET();
       }
    }
    while(1){
      CH563NET_MainTask();                                                      /* CH563NETҪѭвϵ */
      if(CH563NET_QueryGlobalInt())CH561NET_HandleGlobalInt();                  /* ѯжϣжϣȫжϴ */     
    }
}

/*********************************** endfile **********************************/
